<?php
/**********************************
*	@package: PerfCMS			  *
*	@year: 2012					  *
*	@author: Artas				  *
*	@link: http://perfcms.ru	  *
**********************************/
if($user['level'] < 6 || !isset($user)) { header('Location: /'); exit;}
$locate	= 'in_padmin';
if(file_exists(SYS.'/ini/system_info.ini')) 
{
	$perfcms_ver_p = parse_ini_file(SYS.'/ini/system_info.ini');
	$perfcms_ver = $perfcms_ver_p['perfcms_ver'];
} 
elseif(file_exists('perfcms_ver.txt')) 
{
	$perfcms_ver = file_get_contents('perfcms_ver.txt');
} 
else 
{
	$perfcms_ver = 'Undefined! Please check last version of cms on <a href="http://perfcms.org.ua">Official site</a>';
}
$perfcms_last_stable = file_get_contents('http://perfcms.org.ua/perfcms/last_version.txt');
$title = $lang->word('padmin_system_info');
require_once(SYS.'/view/header.php');
$tpl->div('title', $lang->word('padmin_system_info'));
$tpl->div('menu', NAV . '<b>PerfCMS ver: </b>'.$perfcms_ver);
$tpl->div('menu', NAV . '<b>PerfCMS '.$lang->word('last_stable_release').': </b>'.$perfcms_last_stable.' '.($perfcms_ver < $perfcms_last_stable ? '[<a href="/padmin/info?new_version">'. $lang->word('new_version').'</a>]' : NULL));
if(isset($_GET['new_version'])) 
{ 
	$tpl->div('post', output(file_get_contents('http://perfcms.org.ua/perfcms/changelog.txt')));
}
$tpl->div('menu', NAV . '<b>Build</b>: '.$perfcms_ver_p['perfcms_build']);
$tpl->div('menu', NAV . '<b>PHP ver: </b>'. PHP_VERSION);
$tpl->div('menu', NAV . '<b>PHP PDO: </b>'.(class_exists('pdo') ? '<span class="green">ON</span>' : '<span class="red">OFF</span>'));
$tpl->div('block', img('admin.png') .'<a href="/padmin/">'. $lang->word('padmin') .'</a><br/>'. HICO .'<a href="/">'. $lang->word('home') .'</a>');
require_once(SYS.'/view/footer.php');
?>